'use strict';Object.defineProperty(exports,"__esModule",{value:true});var _extends2=require('babel-runtime/helpers/extends');var _extends3=_interopRequireDefault(_extends2);var _entries=require('babel-runtime/core-js/object/entries');var _entries2=_interopRequireDefault(_entries);var _assign=require('babel-runtime/core-js/object/assign');var _assign2=_interopRequireDefault(_assign);var _react=require('react');var _react2=_interopRequireDefault(_react);var _injectorShape=require('./injectorShape');var _shallowEqual=require('../../utils/shallowEqual');var _shallowEqual2=_interopRequireDefault(_shallowEqual);var _isPlainObject=require('../../utils/isPlainObject');var _isPlainObject2=_interopRequireDefault(_isPlainObject);var _invariant=require('invariant');var _invariant2=_interopRequireDefault(_invariant);var _constants=require('../../constants');var _castToFunction=require('../../utils/castToFunction');var _castToFunction2=_interopRequireDefault(_castToFunction);var _processStyleObject=require('../../core/processStyleObject');var _processStyleObject2=_interopRequireDefault(_processStyleObject);var _processStyleTree=require('../../core/processStyleTree');var _processStyleTree2=_interopRequireDefault(_processStyleTree);var _stampObject=require('../../core/stampObject');function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj};}function getDisplayName(Component){return Component.displayName||Component.name||'Component';}const nonProductionEnv=typeof process!=='undefined'&&typeof process.env!=='undefined'&&process.env.NODE_ENV!=='production';let nextVersion=0;function injector(styleTree){const version=nextVersion++;return function wrapWithInject(WrappedComponent){const displayName=`inject(${getDisplayName(WrappedComponent)})`;class Inject extends _react.Component{constructor(props,context){super(props,context);this.version=version;const{[_constants.CONFIGURATIONS]:configs,[_constants.PIPELINE]:pipeline}=context;(0,_invariant2.default)(configs,(0,_constants.UNWRAPPED_INJECTOR_ERR)(this.constructor.displayName));this.state={styles:(0,_processStyleTree2.default)(styleTree,pipeline,configs)};this.processStyle=this.processStyle.bind(this);this.computeStyle=this.computeStyle.bind(this);}computeStyle(...styles){var _this=this;return styles.reduce(function(acc,style){if(!style||(0,_stampObject.isInlineStylerObject)(style))return(0,_assign2.default)(acc,style);(0,_entries2.default)(style).forEach(function([styleKey,styleValue]){if(styleValue){(0,_assign2.default)(acc,_this.state.styles[styleKey]);}});return acc;},{});}processStyle(styleObject){if(!styleObject||(0,_stampObject.isInlineStylerObject)(styleObject))return styleObject;const{[_constants.PIPELINE]:processingPipeline,[_constants.CONFIGURATIONS]:configs}=this.context;return(0,_processStyleObject2.default)(styleObject,processingPipeline,configs);}shouldComponentUpdate(nextProps,nextState,nextContext){return!(0,_shallowEqual2.default)(this.context[_constants.CONFIGURATIONS],nextContext[_constants.CONFIGURATIONS])||!(0,_shallowEqual2.default)(this.props,nextProps);}componentWillReceiveProps(nextProps,nextContext){const nextConfigs=nextContext[_constants.CONFIGURATIONS];if(!(0,_shallowEqual2.default)(this.context[_constants.CONFIGURATIONS],nextConfigs)){const nextPipeline=nextContext[_constants.PIPELINE];this.forceUpdateStyle(nextPipeline,nextConfigs);}}forceUpdateStyle(pipeline,configs){this.setState({styles:(0,_processStyleTree2.default)(styleTree,pipeline,configs)});}render(){return _react2.default.createElement(WrappedComponent,(0,_extends3.default)({},this.props,{styles:this.state.styles,computeStyle:this.computeStyle,processStyle:this.processStyle}));}}if(nonProductionEnv){Inject.prototype.componentWillUpdate=function componentWillUpdate(){if(this.version===version)return;this.version=version;this.forceUpdateStyle(this.context[_constants.PIPELINE],this.context[_constants.CONFIGURATIONS]);};}Inject.displayName=displayName;Inject.WrappedComponent=WrappedComponent;Inject.contextTypes=_injectorShape.contextTypes;return Inject;};};exports.default=injector;